#include "Create.h"

#include "Module.h"

#include "Project.h"
#include "Model.h"
#include "Model_kit.h"

#include "Abstracts.h"

#include "User.h"
#include "Bond_detector.h"
#include "Molecular_detector.h"

//fix remove
#include "Panel_free_drawing.h"

namespace MM
{

class Module_free_drawing : public Module
{
    static Module_free_drawing  singleton_;
                                Module_free_drawing() ;
    void                        init ();

    void                        free_drawing  ();
    void                        detect_bonds  ();
    void                        detect_molecules ();
};
Module_free_drawing  Module_free_drawing::singleton_;


Module_free_drawing::Module_free_drawing () : Module ("Free drawing") { }

void  Module_free_drawing::
init ()
{
    adopt_command (create_command (*this, &Module_free_drawing::free_drawing))
        .set_icon        ("Build", "free_drawing.png")
        .set_tool_tip    ("Draw molecule with mouse")
        .set_menu        ("&Build", "&Free drawing");

    insert_menu_separator ("&Build");
    
    adopt_command (create_command (*this, &Module_free_drawing::detect_bonds))
        .set_menu        ("&Build", "Detect bonds");

    adopt_command (create_command (*this, &Module_free_drawing::detect_molecules))
        .set_menu        ("&Build", "Detect molecules");


    insert_menu_separator ("&Build");
}

void Module_free_drawing::
detect_bonds ()
{
    Bond_detector detector (Project::singleton().current_model());
    detector.execute ();
}

void Module_free_drawing::
detect_molecules ()
{
    Molecular_detector detector (Project::singleton().current_model());
    detector.execute ();
}

void Module_free_drawing::
free_drawing ()
{
    Panel_free_drawing::singleton()->popup ();
}

}//MM
